<?php
/*
 * Signup
 * ------
 *
 * Second stage of signing up for membership.
 * This section will only be run if the input has been
 * validated first (i.e. the first form submits signup_validate,
 * and the second one calls us (signup)).
 *
 * We then send out a mail asking them to confirm their membership,
 * and we insert a member_status of 'Applied' into the database.
 *
 * (C)2003 Stewart Smith
 * Distributed under the GPL.
 */

if($_POST['first_name']==''
   || $_POST['last_name']==''
   || $_POST['address1']==''
   || $_POST['suburb']==''
   || $_POST['postcode']==''
   || $_POST['country']==''
   || $_POST['email']=='')
{
  $_POST['function']='signup_validate';
}
else
{
  /*
   * FIXME: This should be one transaction. Crashing halfway isn't that
   * bad, we're just left with records in members which aren't a member
   * of anything.
   */
  $id = $dbh->nextId('public.members_id_seq');
  
  if($_POST['Sex']=='Male')
    $sexval = 'M';
  else if ($_POST['Sex']=='Female')
    $sexval = 'F';
  else
    $sexval = ' ';
  
  sql_insert('members',array(
			     'id'          => $id,
			     'first_name'  => $_POST['first_name'],
			     'middle_name' => $_POST['middle_name'],
			     'last_name'   => $_POST['last_name'],
			     'dob'         => $_POST['dob'],
			     'sex'         => $sexval,
			     'address1'    => $_POST['address1'],
			     'address2'    => $_POST['address2'],
			     'suburb'      => $_POST['suburb'],
			     'postcode'    => $_POST['postcode'],
			     'state'       => $_POST['state'],
			     'country'     => $_POST['country'],
			     'email'       => $_POST['email'],
			     'phone_home'  => $_POST['phone_home'],
			     'phone_mobile'=> $_POST['phone_mobile']));
  /* We don't need to quote anything
     in this query as it's all valid anyway (from the DB or subselect).
       
     This basically stores that the member (created above) is applying for
     membership to our organisation (as set in the config). The 'Pending'
     type of membership lasts for a year. Although it could be different...
  */
  $sql = 'insert into org_members (org_id,member_id,member_type_id,start_date,expiry) values ('.$config['org_id'].','.$id.",(select id from member_types where type='Applied'),now(),now()+'1year')";
  my_syslog(LOG_DEBUG,$sql);
  $result = $dbh->query($sql);
  if (DB::isError($result)) {
    my_syslog(LOG_INFO,$result->getMessage());
  }
  mail("membership-admin@lists.linux.org.au,".$_POST['email'],
       "Application for Linux Australia Membership",
       "Somebody (most likely you) has submitted this email address\r\n".
       "as their email address when applying for Linux Australia\r\n".
       "<URL http://www.linux.org.au/> membership.\r\n\r\n".
       "On ".date("F j, Y, g:i a")." the following data was\r\n".
       "submitted on our website:\r\n".
       "First Name: ".$_POST['first_name']."\r\n".
       "Middle Name/Initial: ".$_POST['middle_name']."\r\n".
       "Surname: ".$_POST['last_name']."\r\n".
       "Sex: ".$_POST['Sex']."\r\n".
       "Address 1: ".$_POST['address1']."\r\n".
       "Address 2: ".$_POST['address2']."\r\n".
       "Suburb: ".$_POST['suburb']."\r\n".
       "Postcode: ".$_POST['postcode']."\r\n".
       "State: ".$_POST['state']."\r\n".
       "Country: ".$_POST['country']."\r\n".
       "Email: ".$_POST['email']."\r\n".
       "Home Phone: ".$_POST['phone_home']."\r\n".
       "Mobile Phone: ".$_POST['phone_mobile']."\r\n\r\n".
       "YOUR APPLICATION IS NOT READY YET!\r\n".
       "You must visit this link to confirm that this application\r\n".
       "is valid. If you have received this message erroneously, \r\n".
       "just ignore it and it will go away.\r\n\r\n".
       "http://www.linux.org.au/membership/?page=confirm_membership&id=".$id.
       "\r\n"
       );
}
?>